package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

import net.minecraft.world.phys.shapes.Shapes;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.item.context.BlockPlaceContext;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.shapes.CollisionContext;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.world.SimpleMenuProvider;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraft.core.Direction;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.phys.shapes.VoxelShape;
import net.minecraft.network.chat.Component;
import net.minecraft.world.level.block.HorizontalDirectionalBlock;

public class GemCuttingBlock extends HorizontalDirectionalBlock
{
    public static final Component NAME;
    public static final VoxelShape SHAPE;
    
    public GemCuttingBlock(final BlockBehaviour.Properties props) {
        super(props);
        this.m_49959_((BlockState)((BlockState)this.f_49792_.m_61090_()).m_61124_((Property)GemCuttingBlock.f_54117_, (Comparable)Direction.NORTH));
    }
    
    protected void m_7926_(final StateDefinition.Builder<Block, BlockState> builder) {
        builder.m_61104_(new Property[] { (Property)GemCuttingBlock.f_54117_ });
    }
    
    public InteractionResult m_6227_(final BlockState state, final Level worldIn, final BlockPos pos, final Player player, final InteractionHand handIn, final BlockHitResult hit) {
        if (worldIn.f_46443_) {
            return InteractionResult.SUCCESS;
        }
        player.m_5893_(this.m_7246_(state, worldIn, pos));
        return InteractionResult.CONSUME;
    }
    
    public MenuProvider m_7246_(final BlockState state, final Level world, final BlockPos pos) {
        return (MenuProvider)new SimpleMenuProvider((id, pInv, player) -> new GemCuttingMenu(id, pInv, ContainerLevelAccess.m_39289_(world, pos)), GemCuttingBlock.NAME);
    }
    
    public VoxelShape m_5940_(final BlockState pState, final BlockGetter pLevel, final BlockPos pPos, final CollisionContext pContext) {
        return GemCuttingBlock.SHAPE;
    }
    
    public void m_5871_(final ItemStack pStack, final BlockGetter pLevel, final List<Component> list, final TooltipFlag pFlag) {
        list.add((Component)Component.m_237115_(this.m_7705_() + ".desc").m_130940_(ChatFormatting.GRAY));
    }
    
    public BlockState m_5573_(final BlockPlaceContext pContext) {
        return (BlockState)this.m_49966_().m_61124_((Property)GemCuttingBlock.f_54117_, (Comparable)pContext.m_8125_().m_122424_());
    }
    
    static {
        NAME = (Component)Component.m_237115_("menu.apotheosis.gem_cutting");
        SHAPE = Shapes.m_83124_(m_49796_(0.0, 12.0, 0.0, 16.0, 16.0, 16.0), new VoxelShape[] { m_49796_(0.0, 0.0, 0.0, 2.0, 16.0, 2.0), m_49796_(0.0, 0.0, 14.0, 2.0, 16.0, 16.0), m_49796_(14.0, 0.0, 0.0, 16.0, 16.0, 2.0), m_49796_(14.0, 0.0, 14.0, 16.0, 16.0, 16.0) });
    }
}
